<?php

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array();
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');

// ############################# LOG ACTION ###############################
log_admin_action();

define('BATCH_NUMBERS',100);

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
ini_set("default_socket_timeout",10);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'config';
}
print_cp_header($vbphrase['123flashchat']);
if ($_REQUEST['do'] == "doconfig")
{
    $vbulletin->input->clean_array_gpc('p', array(
        'server' => TYPE_INT,
        'c_loc'  => TYPE_STR,
        'room'   => TYPE_STR,
        'status' => TYPE_INT,
        'room_list' => TYPE_INT,
        'user_list' => TYPE_INT,
        's_host' => TYPE_STR,
        's_port' => TYPE_INT,
        's_http_port' => TYPE_INT,
        's_local' => TYPE_INT,
        'client' => TYPE_INT,
        'c_embed'   => TYPE_INT,
        'c_full' => TYPE_INT,
        'c_width'   => TYPE_INT,
        'c_height'  => TYPE_INT,
        'c_lang' => TYPE_STR,
        'c_skin' => TYPE_STR,
    ));
    $fc_row['fc_server'] = $vbulletin->GPC['server'];
    switch ($fc_row['fc_server'])
    {
        case 0:
            if ($vbulletin->GPC['s_local']){
                $fc_row['fc_server_host'] = ($vbulletin->GPC['s_host'] != '127.0.0.1') ? $vbulletin->GPC['s_host'] : parse_url($vbulletin->options['bburl'], PHP_URL_HOST);
                $fc_row['fc_server_port'] = $vbulletin->GPC['s_port'] ? $vbulletin->GPC['s_port'] : 51127;
                $fc_row['fc_http_port'] = $vbulletin->GPC['s_http_port'] ? $vbulletin->GPC['s_http_port'] : 35555;
                $fc_row['fc_api_url'] = 'http://' . $fc_row['fc_server_host'] . ':' . $fc_row['fc_http_port'] . '/'; 
                $fc_row['fc_client_loc'] = $fc_row['fc_api_url'];
                $s_own_loc = validate_server($fc_row['fc_server_host'], $fc_row['fc_server_port']);
                $c_own_loc = validate_client($fc_row['fc_client_loc']);
                $da = validate_data_api($fc_row['fc_api_url'] . 'online.js');
                if ($s_own_loc)
                {
                    $error[] = 'Chat Server host or port is configured incorrectly';
                }
                if ($da || $c_own_loc)
                {
                    $error[] = 'Chat Server host or http_port is configured incorrectly';
                }
            }else{
                $fc_row['fc_server_host'] = parse_url($vbulletin->options['bburl'], PHP_URL_HOST);
                $fc_row['fc_server_port'] = 51127;
                $fc_row['fc_http_port'] = 35555;
                $fc_row['fc_api_url'] = 'http://' . $fc_row['fc_server_host'] . ':' . $fc_row['fc_http_port'] . '/';
                $fc_row['fc_client_loc'] = $fc_row['fc_api_url']; 
            }
            $fc_row['fc_client'] = $vbulletin->GPC['client'];
            if (!$fc_row['fc_client'])
            {
                $fc_row['fc_client_skin'] = $vbulletin->GPC['c_skin'];
            }
            break;
        case 1:
            $fc_row['fc_client_loc'] = $vbulletin->GPC['c_loc'] . (substr($vbulletin->GPC['c_loc'],-1,1) != '/' ? '/' : '');
            $fc_row['fc_server_host'] = parse_url($fc_row['fc_client_loc'], PHP_URL_HOST);
            if ($content = @file_get_contents($fc_row['fc_client_loc']))
            {
                preg_match('/init_port=([0-9]*)/', $content, $matches);
                $fc_row['fc_server_port'] = $matches[1];
            }
            $fc_row['fc_api_url'] = 'http://' . $fc_row['fc_server_host'] . '/';
            $fc_row['fc_group'] = substr(parse_url($fc_row['fc_client_loc'], PHP_URL_PATH),1,-1);
            $c_own_loc = validate_client($fc_row['fc_client_loc']);
            $da = validate_data_api($fc_row['fc_api_url'] . 'online.js?group=' . $fc_row['fc_group']);
            if ($c_own_loc or $da)
            {
                $error[] = 'Client Location is configured incorrectly';
            }
            $fc_row['fc_client'] = $vbulletin->GPC['client'];
            if (!$fc_row['fc_client'])
            {
                $fc_row['fc_client_skin'] = $vbulletin->GPC['c_skin'];
            }
            break;
        case 2:
            $fc_row['fc_room'] = $vbulletin->GPC['room'] ? $vbulletin->GPC['room'] : $vbulletin->options['bbtitle'];
            $fc_row['fc_client'] = 0;
            $fc_row['fc_client_skin'] = $vbulletin->GPC['c_skin'];
            break;
    }
	if ($fc_row['fc_status'] = $vbulletin->GPC['status'])
	{
	    if ($fc_row['fc_server'] !=2 )
		{
			$fc_row['fc_room_list'] = $vbulletin->GPC['room_list'];
		}
	    $fc_row['fc_user_list'] = $vbulletin->GPC['user_list'];
	}

	$fc_row['fc_client_embed'] = $vbulletin->GPC['c_embed'];

	if ($vbulletin->GPC['c_full'])
    {
        $fc_row['fc_client_width'] = '100%';
        $fc_row['fc_client_height'] = '100%';
	 }
	 else
	 {
	     $fc_row['fc_client_width'] = $vbulletin->GPC['c_width'] ? $vbulletin->GPC['c_width'] : 800;
	     $fc_row['fc_client_height'] = $vbulletin->GPC['c_height'] ? $vbulletin->GPC['c_height'] : 600;
	 }
	$fc_row['fc_client_lang'] = $vbulletin->GPC['c_lang'];
    if (!sizeof($error))
	{
		foreach ($fc_row as $varname => $value)
		{
			$vbulletin->db->query_write("
				UPDATE " . TABLE_PREFIX . "setting
				SET value = '" . $vbulletin->db->escape_string($value) . "'
				WHERE varname = '" . $vbulletin->db->escape_string($varname) . "'
			");
		}
		build_options();
	    define('CP_REDIRECT', '123flashchat_admin.php');
	    print_stop_message('saved_settings_successfully');
	}
	else
	{
		$error_msg=implode('<br />',$error);
		$_REQUEST['do'] = "config";
	}
}
if ($_REQUEST['do'] == "config")
{
    if (!isset($fc_row))
    {
        $fc_row['fc_server'] = $vbulletin->options['fc_server'];
        $fc_row['fc_client_loc'] = $vbulletin->options['fc_client_loc'];
        $fc_row['fc_room'] = $vbulletin->options['fc_room'];
        $fc_row['fc_status'] = $vbulletin->options['fc_status'];
        $fc_row['fc_room_list'] = $vbulletin->options['fc_room_list'];
        $fc_row['fc_user_list'] = $vbulletin->options['fc_user_list'];
       
        $fc_row['fc_server_host'] = $vbulletin->options['fc_server_host'];
        $fc_row['fc_server_port'] = $vbulletin->options['fc_server_port'];
        $fc_row['fc_http_port'] = $vbulletin->options['fc_http_port'];
        $fc_row['fc_client'] = $vbulletin->options['fc_client'];
        $fc_row['fc_client_embed'] =$vbulletin->options['fc_client_embed']; 
        $fc_row['fc_client_width'] =$vbulletin->options['fc_client_width'];
        $fc_row['fc_client_height'] =$vbulletin->options['fc_client_height']; 
        $fc_row['fc_client_lang'] =$vbulletin->options['fc_client_lang']; 
        $fc_row['fc_client_skin'] =$vbulletin->options['fc_client_skin']; 
    }
	$s_own_loc = validate_server('127.0.0.1', 51127);
	$c_own_loc = validate_client('http://127.0.0.1:35555/');
	$c_loc = $s_own_loc || $c_own_loc;
	

	?>
	<script type="text/javascript">
	function dE(n, s)
	{
		var e = document.getElementById(n);
		if (!s)
		{
			s = (e.style.display == '') ? -1 : 1;
		}
		e.style.display = (s == 1) ? '' : 'none';
	}
	</script>
    <script type="text/javascript">
    function setClientSize(n)
    { 
        var wh = [[634,476],[725,476],[800,600]];
        if (<?php echo (($fc_row['fc_client_height'] == '100%') ? 0 : 1); ?>)
        {
            wh[<?php echo $fc_row['fc_client']; ?>] = ['<?php echo $fc_row['fc_client_width']; ?>','<?php echo $fc_row['fc_client_height']; ?>'];
        }
        document.getElementById('c_width').value = wh[n][0];
        document.getElementById('c_height').value = wh[n][1];
    } 
	</script>
	<?php

	//* Command list *

	// Redlieving of the commands 
	
	//var_dump((isset($fc_row) ? $fc_row['fc_server'] : $fc_row['fc_server']));
	print_form_header('123flashchat_admin', 'doconfig');

    print_table_header($vbphrase['chat_settings'], 2, 0);
	echo '<tbody  ' . ($error_msg ? '' : 'style="display: none"') . '><tr valign="top">
	<td class="alt1"></td>
	<td class="alt1"><font color="red">'. $error_msg .'</font></td>
</tr></tbody>';
	print_description_row("<b>Basic Setting</b>");
	echo '<tbody><tr valign="top">
	<td class="alt1" width="30%">Chat Server Mode:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		    <label for="s_0"><input type="radio" name="server" id="s_0" value="0" onClick="dE(\'c\', 1);dE(\'o_skin\', 1);dE(\'free_skin\', -1);dE(\'c_full_b\', 1);dE(\'s_config\', 1);dE(\'room_list\', 1);dE(\'s_own\', 1);dE(\'s_fc\', -1);dE(\'s_free\', -1);dE(\'s_auth\', 1);"' . (($fc_row['fc_server']  == 0) ? 'checked="checked"' : '') . '>Chat server hosted by your own</label><br>
		    <label for="s_1"><input type="radio" name="server" id="s_1" value="1" onClick="dE(\'c\', 1);dE(\'o_skin\', 1);dE(\'free_skin\', -1);dE(\'c_full_b\', 1);dE(\'s_config\', -1);dE(\'room_list\', 1);dE(\'s_own\', -1);dE(\'s_fc\', 1);dE(\'s_free\', -1);dE(\'s_auth\', 1);"' . (($fc_row['fc_server']  == 1) ? 'checked="checked"' : '') . '>Chat server hosted by 123flashchat</label><br>
		    <label for="s_2"><input type="radio" name="server" id="s_2" value="2" onClick="document.getElementById(\'c_wh\').checked=true;dE(\'c\', -1);dE(\'o_skin\', -1);dE(\'free_skin\', 1);dE(\'c_full_b\', -1);dE(\'s_config\', -1);dE(\'room_list\', -1);dE(\'s_own\', -1);dE(\'s_fc\', -1);dE(\'s_free\', 1);dE(\'s_auth\', -1);"' . (($fc_row['fc_server']  == 2) ? 'checked="checked"' : '') . '>Chat server hosted by 123flashchat free of charge</label>
		    </td>
		</tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody ' . ($c_loc ?  '' : 'style="display: none"') . '><tr id="s_own" ' . (($fc_row['fc_server'] != 0) ? 'style="display: none"' : '') . '>
	<td class="alt1"></td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
		    <td><font color="#001F60">Note*: Please install 123FlashChat Server first before enable this Mod.</font><br /><a href="http://www.123flashchat.com/download-now.html?p=123flashchat.' . ((PATH_SEPARATOR==':') ? (stristr(PHP_OS, 'darwin') ?  'dmg' : 'sh') : 'exe') . '" target="_blank">Free Download</a></td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody id="s_fc" ' . (($fc_row['fc_server'] != 1) ? 'style="display: none"' : '') . '><tr>
	<td class="alt1"></td>
    <td class="alt1"><font color="#001F60">123FlashChat Hosting Service start at $30.</font> <a href="http://www.123flashchat.com/host.html" target="_blank"> Buy Now</a></td>
	</tr><tr>
	<td class="alt1">Chat Client Location:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
		    <td><input name="c_loc"  class="bginput" value="' . $fc_row['fc_client_loc'] . '" size="50"></td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
    echo '<tbody id="s_free" ' . (($fc_row['fc_server']  != 2) ? 'style="display: none"' : '') . '><tr valign="top">
	<td class="alt1">Chat Room Name:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td><div id="ctrl_room"><input type="text" class="bginput" name="room" id="it_room_1" value="' . $fc_row['fc_room'] . '" size="50" dir="ltr" tabindex="1"></div></td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody id="s_auth" ' . (($fc_row['fc_server']  != 2) ?  '' : 'style="display: none"') . '><tr>
	<td class="alt1"></td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
		    <td><font color="#001F60">To integrate users for auto login on chat, please open admin panel > System Settings > Integration Panel, set authentication URL to:<br />' . $vbulletin->options['bburl'] . '/login_chat.php?username=%username%&password=%password%</font></td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody><tr>
	<td class="alt1">Show Chat Status:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		        <label><input type="radio" name="status" value="1" onclick="dE(\'status_block\', 1);" ' . (($fc_row['fc_status'] == 1) ? 'checked="checked"' : '') . '>Yes</label>
		        <label><input type="radio" name="status" value="0" onclick="dE(\'status_block\', -1);" ' . (($fc_row['fc_status'] == 0) ? 'checked="checked"' : '') . '>No</label>
		    </td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody id="status_block" ' . (($fc_row['fc_status'] == 0) ? 'style="display: none"' : '') . '><tr id="room_list" ' . (($fc_row['fc_server']  == 2) ? 'style="display: none"' : '') . '>
	<td class="alt1">Show Room List:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		        <label><input type="radio" name="room_list" value="1" ' . (($fc_row['fc_room_list'] == 1) ? 'checked="checked"' : '') . '>Yes</label>
		        <label><input type="radio" name="room_list" value="0" ' . (($fc_row['fc_room_list'] == 0) ? 'checked="checked"' : '') . '>No</label>
		    </td>
	    </tr></tbody></table>
	</td>
</tr>
';
	echo '<tr>
	<td class="alt1">Show User List:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		        <label><input type="radio" name="user_list" value="1" ' . (($fc_row['fc_user_list'] == 1) ? 'checked="checked"' : '') . '>Yes</label>
		        <label><input type="radio" name="user_list" value="0" ' . (($fc_row['fc_user_list'] == 0) ? 'checked="checked"' : '') . '>No</label>
		    </td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	print_description_row("<b>Advanced Settings</b>");
    echo '<tbody ' . ($c_loc ? '' : 'style="display: none"') . '><tr id="s_config" ' . (($fc_row['fc_server']  != 0) ? 'style="display: none"' : '') . '>
    <td class="alt1">Chat Server:</td>
    <td class="alt1">
        <input type="hidden" name="s_local" value="'. $c_loc . '">
        <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody>
        <tr valign="top">
	        <td class="alt1">Host:</td>
	        <td class="alt1">
	            <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	                <td><div id="ctrl_s_host"><input type="text" class="bginput" name="s_host" id="it_room_1" value="' . $fc_row['fc_server_host'] . '" size="50" dir="ltr" tabindex="1"></div></td>
	            </tr></tbody></table>
	        </td>
        </tr>
        <tr valign="top">
	        <td class="alt1">Port:</td>
	        <td class="alt1">
	            <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	                <td><div id="ctrl_s_port"><input type="text" class="bginput" name="s_port" id="it_room_1" value="' . $fc_row['fc_server_port'] . '" size="50" dir="ltr" tabindex="1"></div></td>
	            </tr></tbody></table>
	        </td>
        </tr>
        <tr valign="top">
	        <td class="alt1">Http Port:</td>
	        <td class="alt1">
	            <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	                <td><div id="ctrl_http_port"><input type="text" class="bginput" name="s_http_port" id="it_room_1" value="' . $fc_row['fc_http_port'] . '" size="50" dir="ltr" tabindex="1"></div></td>
	            </tr></tbody></table>
	        </td>
        </tr>
        </tbody></table>
    </td>
</tr></tbody>
';
	echo '<tbody id="c" ' . (($fc_row['fc_server']  == 2) ? 'style="display: none"' : '') . '><tr valign="top">
	<td class="alt1" width="30%">Chat Client Mode:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		    <label for="c_0"><input type="radio" name="client" id="c_0" value="0" onClick="dE(\'s_skin\', 1);setClientSize(0);"' . (($fc_row['fc_client'] == 0) ? 'checked="checked"' : '') . '>Standard Chat</label><br>
		    <label for="c_1"><input type="radio" name="client" id="c_1" value="1" onClick="dE(\'s_skin\', -1);setClientSize(1);"' . (($fc_row['fc_client'] == 1) ? 'checked="checked"' : '') . '>Html Chat</label><br>
		    <label for="c_2"><input type="radio" name="client" id="c_2" value="2" onClick="dE(\'s_skin\', -1);setClientSize(2);"' . (($fc_row['fc_client'] == 2) ? 'checked="checked"' : '') . '>Avatar Chat</label>
		    </td>
		</tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody><tr>
	<td class="alt1">Chat Present Mode:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		        <label><input type="radio" name="c_embed" value="1" onclick="dE(\'c_full_block\', -1);document.getElementById(\'c_wh\').checked=true;" ' . (($fc_row['fc_client_embed'] == 1) ? 'checked="checked"' : '') . '>Embeded</label>
		        <label><input type="radio" name="c_embed" value="0" onclick="dE(\'c_full_block\', 1);" ' . (($fc_row['fc_client_embed'] == 0) ? 'checked="checked"' : '') . '>Popup</label>
		    </td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody><tr>
	<td class="alt1">Chat Client Size:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td>
		        <label><input type="radio" name="c_full" id="c_wh" value="0" ' . (($fc_row['fc_client_height'] != '100%') ? 'checked="checked"' : '') . '>Width: <input name="c_width"  id="c_width" class="bginput" value="' . ($fc_row['fc_client_width'] == '100%' ? '' : $fc_row['fc_client_width']) .'">&nbsp;&nbsp;Height:<input name="c_height"  id="c_height"  class="bginput" value="' . ($fc_row['fc_client_height'] == '100%' ? '' : $fc_row['fc_client_height']) .'"></label><br>
		        <span id="c_full_b" ' . (($fc_row['fc_server'] == 2) ? 'style="display: none"' : '') . '><label id="c_full_block" ' . (($fc_row['fc_client_embed'] == 1) ? 'style="display: none"' : '') . '><input type="radio" name="c_full" value="1" ' . (($fc_row['fc_client_height'] == '100%') ? 'checked="checked"' : '') . '>Full Screen</label></span>
		    </td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody><tr>
	<td class="alt1">Chat Client Language:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td><div id="ctrl_c_lang">
                <select name="c_lang" id="sel_c_lang_3" tabindex="1" class="bginput">
		            <option value="*" ' . (($fc_row['fc_client_lang'] == '*') ? 'selected="selected"' : '') . '>Auto detect</option>
		            <option value="en" ' . (($fc_row['fc_client_lang'] == 'en') ? 'selected="selected"' : '') . '>English</option>
		            <option value="zh-CN" ' . (($fc_row['fc_client_lang'] == 'zh-CN') ? 'selected="selected"' : '') . '>GB Chinese</option>
		            <option value="zh-TW" ' . (($fc_row['fc_client_lang'] == 'zh-TW') ? 'selected="selected"' : '') . '>Big5 Chinese</option>
		            <option value="fr" ' . (($fc_row['fc_client_lang'] == 'fr') ? 'selected="selected"' : '') . '>French</option>
		            <option value="it" ' . (($fc_row['fc_client_lang'] == 'it') ? 'selected="selected"' : '') . '>Italian</option>
		            <option value="de" ' . (($fc_row['fc_client_lang'] == 'de') ? 'selected="selected"' : '') . '>German</option>
		            <option value="nl" ' . (($fc_row['fc_client_lang'] == 'nl') ? 'selected="selected"' : '') . '>Dutch</option>
		            <option value="hu" ' . (($fc_row['fc_client_lang'] == 'hu') ? 'selected="selected"' : '') . '>Hungarian</option>
		            <option value="es" ' . (($fc_row['fc_client_lang'] == 'es') ? 'selected="selected"' : '') . '>Spanish</option>
		            <option value="hr" ' . (($fc_row['fc_client_lang'] == 'hr') ? 'selected="selected"' : '') . '>Croatian</option>
		            <option value="tr" ' . (($fc_row['fc_client_lang'] == 'tr') ? 'selected="selected"' : '') . '>Turkish</option>
		            <option value="ar" ' . (($fc_row['fc_client_lang'] == 'ar') ? 'selected="selected"' : '') . '>Arabic</option>
		            <option value="pt" ' . (($fc_row['fc_client_lang'] == 'pt') ? 'selected="selected"' : '') . '>Portuguese</option>
		            <option value="ru" ' . (($fc_row['fc_client_lang'] == 'ru') ? 'selected="selected"' : '') . '>Russian</option>
		            <option value="ko" ' . (($fc_row['fc_client_lang'] == 'ko') ? 'selected="selected"' : '') . '>Korean</option>
		            <option value="serbian" ' . (($fc_row['fc_client_lang'] == 'serbian') ? 'selected="selected"' : '') . '>Serbian</option>
		            <option value="no" ' . (($fc_row['fc_client_lang'] == 'no') ? 'selected="selected"' : '') . '>Norwegian</option>
		            <option value="ja" ' . (($fc_row['fc_client_lang'] == 'ja') ? 'selected="selected"' : '') . '>Japanese</option>
                </select>
            </div><input type="hidden" name="c_skin" id="c_skin" value="' . $fc_row['fc_client_skin'] . '"></td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
	echo '<tbody id="free_skin" ' . (($fc_row['fc_server'] != 2) ? 'style="display: none"' : '') . '><tr>
	<td class="alt1">Chat Client Skin:</td>
	<td class="alt1">
	    <table id="skin" cellpadding="2" cellspacing="3" border="0" width="100%"><tbody>
            <tr>
                <td title="default" bgcolor="#b7cde5" height="15" width="50"></td>
                <td title="green" bgcolor="#99cc67" width="50"></td>
                <td title="orange" bgcolor="#ffff00" width="50"></td>
                <td></td>
            </tr>
            <tr>
                <td title="red" bgcolor="#ff0000" height="15"></td>
                <td title="black" bgcolor="#000000"></td>
                <td title="beige" bgcolor="#897f6f"></td>
            </tr>
            <tr>
                <td title="standard" bgcolor="#66ffff" height="15"></td>
                <td title="clean" bgcolor="#9999ff"></td>
                <td title="artistic" bgcolor="#cc6600"></td>
            </tr>
            
	    </tbody></table>
	    <br>
	    <img src="./fc_' . $fc_row['fc_client_skin']. '.gif" id="standardchat">
	</td>
</tr></tbody>
';
	echo '<tbody id="o_skin" ' . (($fc_row['fc_server'] == 2) ? 'style="display: none"' : '') . '><tr id="s_skin" ' . (($fc_row['fc_client'] != 0) ? 'style="display: none"' : '') . '>
	<td class="alt1">Client Skin</td>
	<td class="alt1">
	    <table id="skin1" cellpadding="2" cellspacing="3" border="0" width="100%"><tbody>
            <tr>
                <td title="default" bgcolor="#b7cde5" height="15" width="50"></td>
                <td title="green" bgcolor="#99cc67" width="50"></td>
                <td title="orange" bgcolor="#ffff00" width="50"></td>
                <td></td>
            </tr>
            <tr>
                <td title="red" bgcolor="#ff0000" height="15"></td>
                <td title="black" bgcolor="#000000"></td>
                <td title="beige" bgcolor="#897f6f"></td>
            </tr>
            <tr>
                <td title="standard" bgcolor="#66ffff" height="15"></td>
                <td title="clean" bgcolor="#9999ff"></td>
                <td title="artistic" bgcolor="#cc6600"></td>
            </tr>
            
	    </tbody></table>
	    <br>
	    <img src="./fc_' . $fc_row['fc_client_skin']. '.gif" id="standardchat1">
	</td>
</tr></tbody>
';
	echo '<tbody><tr>
	<td class="alt1">Post Notifier:</td>
	<td class="alt1">
	    <table cellpadding="0" cellspacing="0" border="0" width="100%"><tbody><tr valign="top">
	        <td><a href="http://www.123flashchat.com/vbb-post-notifier.html" target="_blank">http://www.123flashchat.com/vbb-post-notifier.html</a>
		    </td>
	    </tr></tbody></table>
	</td>
</tr></tbody>
';
    ?>
<script type="text/javascript">
var TblCells=document.getElementById("skin").getElementsByTagName("td");
for (var t=0,curCell; curCell=TblCells[t]; t++)
curCell.onclick = function()
{
    if (this.getAttribute('title'))
    {
        document.getElementById('standardchat').src = './fc_' + this.getAttribute('title')  +'.gif';
        document.getElementById('c_skin').value = this.getAttribute('title');   
    }
}
</script>
<script type="text/javascript">
var TblCells=document.getElementById("skin1").getElementsByTagName("td");
for (var t=0,curCell; curCell=TblCells[t]; t++)
curCell.onclick = function()
{
    if (this.getAttribute('title'))
    {
        document.getElementById('standardchat1').src = './fc_' + this.getAttribute('title')  +'.gif';
        document.getElementById('c_skin').value = this.getAttribute('title');   
    }
}
</script>

    <?php
    echo '<tr> 
	<td class="tfoot" colspan="2" align="center">	<input type="submit" id="submit0" class="button" tabindex="1" value="  Save  " accesskey="s" /> 
	</td></tr>';
	print_table_footer();
}

if ($_REQUEST['do'] == "moreconfig")
{
    //print_table_header($vbphrase['chat'], 2, 0);
    if ($vbulletin->options['fc_server'] == 2)
    {
        echo '<br /><div align="center">
<h3>Sorry! Admin Panel is not available in the Free Chat Hosting Edition. 123FlashChat Full Version starts at $19.</h3> <br /><span>Click the link below to have a live Admin Panel Demo for testing.</span>
<br />
<a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank"><h2>Live Demo</h2></a>
</div>
<br />';
    }
    else
    {
        $admin_url = $vbulletin->options['fc_client_loc'] . 'admin_123flashchat.swf?init_host='.$vbulletin->options['fc_server_host'].'&init_port='.$vbulletin->options['fc_server_port']."&init_user=".rawurlencode($vbulletin->userinfo[username])."&init_password=".$vbulletin->userinfo[password] . (($vbulletin->options['fc_server'] == 1) ? "&init_group=" . $vbulletin->options['fc_group'] : "");
        echo '<div align="center"><object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" width="90%" height="600">
    <param name=movie value="'. $admin_url .'">
    <param name=quality value="high">
    <param name="menu" value="false">
    <embed src="'. $admin_url .'" quality="high" menu="false" width="90%" height="600" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer"></embed>
</object></div>';
    }
	//print_table_footer();
}

print_cp_footer();

    /**
	* Check 123 FlashChat Server Config
	* @parm $host   Chat Server Host
	* @parm $port   Chat Server Port
	* @return integer config status
	*/
    function validate_server($host, $port)
    {   $s_own_loc = 1;
        $apiCommand = '<Init/>';
        $resultDoc = "";
        $fp = @fsockopen($host, $port, $errno, $errstr, 2);
        if($fp)
        {
            fputs($fp,$apiCommand."\0");
            while (!feof($fp))
            {
                $resultDoc .= fgets($fp, 1024);
                $resultDoc = rtrim($resultDoc);
            }
            $parser = xml_parser_create("UTF-8");
            xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
            xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
            if (xml_parse_into_struct($parser, $resultDoc, $values, $tags))
            {
                if($values)
                {
                    $s_own_loc = 0;
                }
                xml_parser_free($parser);
                fclose($fp);
            }
        }
        return $s_own_loc;
    }

    /**
	* Check 123 FlashChat Data api
	* @parm $data_api   Chat Data Api
	* @return integer config status
	*/
    function validate_data_api($data_api)
    {   $da = 1;
        if(@file_get_contents($data_api))
        {
        	$da = 0;
    	}
        return $da;
    }
    
    /**
	* Check 123 FlashChat Client Location
	* @parm $client_loc   Chat Client Location
	* @return integer config status
	*/
    function validate_client($client_loc)
    {
		$c_own_loc = 1;
		$swf = $client_loc . '123flashchat.swf';
        if($headers = @get_headers($swf))
        {   
            $c_own_loc = (substr($headers[0], 9, 3) == '200') ? 0 : 1;
        }
        return $c_own_loc;
    }
?>
